package com.gskinner.effects
{
   import flash.display.*;
   import flash.events.*;
   import flash.filters.*;
   import flash.geom.*;
   
   [Embed(source="/_assets/assets.swf", symbol="com.gskinner.effects.FireFX")]
   public class FireFX extends Sprite
   {
       
      
      private var perlinValid:Boolean = false;
      
      private var bmpsValid:Boolean = false;
      
      private var fireCMF:ColorMatrixFilter;
      
      private var scratchBmp:BitmapData;
      
      private var dispMapF:DisplacementMapFilter;
      
      private var pnt:Point;
      
      private var _distortion:Number = 0.5;
      
      private var endCount:Number;
      
      private var displayBmp:BitmapData;
      
      private var _distortionScale:Number = 0.4;
      
      private var _smoke:Number = 0;
      
      private var _flameHeight:Number = 0.3;
      
      private var perlinBmp:BitmapData;
      
      private var _blueFlame:Boolean = false;
      
      private var drawColorTransform:ColorTransform;
      
      private var _target:DisplayObject;
      
      private var mtx:Matrix;
      
      private var filtersValid:Boolean = false;
      
      private var _flameSpread:Number = 0.3;
      
      private var blurF:BlurFilter;
      
      private var _fadeRate:Number = 0.4;
      
      public function FireFX()
      {
         var _loc1_:DisplayObject = null;
         _fadeRate = 0.4;
         _distortionScale = 0.4;
         _distortion = 0.5;
         _flameHeight = 0.3;
         _flameSpread = 0.3;
         _blueFlame = false;
         _smoke = 0;
         bmpsValid = false;
         perlinValid = false;
         filtersValid = false;
         super();
         _loc1_ = getChildAt(0);
         _loc1_.visible = false;
         _loc1_.height = height;
         _loc1_.width = width;
         scaleX = scaleY = 1;
         mtx = new Matrix();
         pnt = new Point();
         startFire();
      }
      
      public function get blueFlame() : Boolean
      {
         return _blueFlame;
      }
      
      internal function updateFilters() : void
      {
         if(_blueFlame)
         {
            fireCMF = new ColorMatrixFilter([0.8 - 0.55 * _fadeRate,0,0,0,0,0,0.93 - 0.48 * _fadeRate,0,0,0,0,0.1,0.96 - 0.35 * _fadeRate,0,0,0,0.1,0,1,-25 + _smoke * 24]);
            drawColorTransform = new ColorTransform(0,0,0,1,210,240,255,0);
         }
         else
         {
            fireCMF = new ColorMatrixFilter([0.96 - 0.35 * _fadeRate,0.1,0,0,-1,0,0.9 - 0.45 * _fadeRate,0,0,0,0,0,0.8 - 0.55 * _fadeRate,0,0,0,0.1,0,1,-25 + _smoke * 24]);
            drawColorTransform = new ColorTransform(0,0,0,1,255,255,210,0);
         }
         dispMapF = new DisplacementMapFilter(perlinBmp,pnt,1,2,14 * _distortion,-30,"clamp");
         blurF = new BlurFilter(32 * _flameSpread,32 * _flameSpread,1);
         filtersValid = true;
      }
      
      public function set flameSpread(param1:Number) : void
      {
         filtersValid = Boolean(filtersValid) && param1 == _flameSpread;
         _flameSpread = param1;
      }
      
      private function updateBitmaps() : void
      {
         if(displayBmp)
         {
            displayBmp.dispose();
            displayBmp = null;
            scratchBmp.dispose();
            scratchBmp = null;
            perlinBmp.dispose();
            perlinBmp = null;
         }
         displayBmp = new BitmapData(width,height,true,0);
         scratchBmp = displayBmp.clone();
         perlinBmp = new BitmapData(width * 3,height * 3,false,0);
         while(numChildren)
         {
            removeChildAt(0);
         }
         addChild(new Bitmap(displayBmp));
         updatePerlin();
         updateFilters();
         bmpsValid = true;
      }
      
      override public function get height() : Number
      {
         return super.height;
      }
      
      public function set target(param1:DisplayObject) : void
      {
         _target = param1;
         clear();
      }
      
      public function set distortion(param1:Number) : void
      {
         filtersValid = Boolean(filtersValid) && param1 == _fadeRate;
         _distortion = param1;
      }
      
      public function get flameHeight() : Number
      {
         return _flameHeight;
      }
      
      override public function set height(param1:Number) : void
      {
         bmpsValid = Boolean(bmpsValid) && param1 == height;
         super.height = param1 | 0;
      }
      
      public function get smoke() : Number
      {
         return _smoke;
      }
      
      public function set flameHeight(param1:Number) : void
      {
         perlinValid = Boolean(perlinValid) && param1 == _flameHeight;
         _flameHeight = param1;
      }
      
      public function get fadeRate() : Number
      {
         return _fadeRate;
      }
      
      private function doFire(param1:Event) : void
      {
         var _loc2_:Matrix = null;
         if(_target == null)
         {
            return;
         }
         if(!bmpsValid)
         {
            updateBitmaps();
         }
         if(!perlinValid)
         {
            updatePerlin();
         }
         if(!filtersValid)
         {
            updateFilters();
         }
         if(endCount == 0)
         {
            _loc2_ = _target.transform.matrix;
            _loc2_.tx = _target.x - x;
            _loc2_.ty = _target.y - y;
            scratchBmp.fillRect(scratchBmp.rect,0);
            drawColorTransform.alphaOffset = -Math.random() * 200 | 0;
            scratchBmp.draw(_target,_loc2_,drawColorTransform,"add");
            scratchBmp.applyFilter(scratchBmp,scratchBmp.rect,pnt,blurF);
            displayBmp.draw(scratchBmp,mtx,null,"add");
         }
         dispMapF.mapPoint = new Point(-Math.random() * (perlinBmp.width - displayBmp.width) | 0,-Math.random() * (perlinBmp.height - displayBmp.height) | 0);
         displayBmp.applyFilter(displayBmp,displayBmp.rect,pnt,dispMapF);
         displayBmp.applyFilter(displayBmp,displayBmp.rect,pnt,fireCMF);
         if(endCount != 0 && --endCount == 0)
         {
            removeEventListener(Event.ENTER_FRAME,doFire);
         }
      }
      
      public function set distortionScale(param1:Number) : void
      {
         perlinValid = Boolean(perlinValid) && param1 == _distortionScale;
         _distortionScale = param1;
      }
      
      public function set targetName(param1:String) : void
      {
         var targ:DisplayObject = null;
         var value:String = param1;
         targ = parent.getChildByName(value);
         if(targ == null)
         {
            try
            {
               targ = parent[value] as DisplayObject;
            }
            catch(e:*)
            {
            }
         }
         target = targ;
      }
      
      override public function set width(param1:Number) : void
      {
         bmpsValid = Boolean(bmpsValid) && param1 == width;
         super.width = param1 | 0;
      }
      
      public function get target() : DisplayObject
      {
         return _target;
      }
      
      public function get distortion() : Number
      {
         return _distortion;
      }
      
      private function updatePerlin() : void
      {
         perlinBmp.perlinNoise(30 * _distortionScale,20 * _distortionScale,1,-Math.random() * 1000 | 0,false,true,1 | 2,false);
         perlinBmp.colorTransform(perlinBmp.rect,new ColorTransform(1,1 - _flameHeight * 0.5,1,1,0,0,0,0));
         perlinValid = true;
      }
      
      public function clear() : void
      {
         if(displayBmp)
         {
            displayBmp.fillRect(displayBmp.rect,0);
         }
      }
      
      public function get flameSpread() : Number
      {
         return _flameSpread;
      }
      
      public function stopFire() : void
      {
         if(endCount == 0)
         {
            endCount = 20;
         }
      }
      
      public function get distortionScale() : Number
      {
         return _distortionScale;
      }
      
      override public function get width() : Number
      {
         return super.width;
      }
      
      private function startFire() : void
      {
         endCount = 0;
         addEventListener(Event.ENTER_FRAME,doFire);
      }
      
      public function set smoke(param1:Number) : void
      {
         filtersValid = Boolean(filtersValid) && param1 == _smoke;
         _smoke = param1;
      }
      
      public function set blueFlame(param1:Boolean) : void
      {
         filtersValid = Boolean(filtersValid) && param1 == _blueFlame;
         _blueFlame = param1;
      }
      
      public function set fadeRate(param1:Number) : void
      {
         filtersValid = Boolean(filtersValid) && param1 == _fadeRate;
         _fadeRate = param1;
      }
   }
}
